// Copyright 2001 Macromedia, Inc. All rights reserved.

/* SITE WIDE HELPER FUNCTIONS BEGIN */

function GetSiteWideSourceDisplayNode(sourceName, nodeName, iconFileName, dataSource,name)
{
  var DSL = new Array()

  var siteURL = dw.getSiteRoot()
  var bindingsArray = new Array()

  if (siteURL.length)
  {
    getValuesFromNote(siteURL, bindingsArray, sourceName, sourceName + "Count")
    if (bindingsArray.length > 0)
    {
      DSL.push(new ObjectInfo(nodeName, iconFileName, false, dataSource,name))
    }
  }

  return DSL
}


function GetBindingsOfSiteWideSource(sourceName, dataSource)
{
  var bindingsArray = new Array()
  var outArray = new Array

  var siteURL = dw.getSiteRoot()

  if (siteURL.length)
  {
    getValuesFromNote(siteURL, bindingsArray, sourceName, sourceName + "Count")
    outArray = GenerateObjectInfoForSourceBindings(bindingsArray, datasourceleaf_filename, dataSource)
  }

  return outArray 
}


function DeleteBindingOfSiteWideSource(sourceName, bindingName)
{
  var siteURL = dw.getSiteRoot()
  if (siteURL.length)
  {
    deleteValueFromNote(siteURL, sourceName + "Count", sourceName, bindingName)
  }
}


function SaveSiteWideValue(sourceName)
{
  var siteURL = dw.getSiteRoot()

  if (siteURL.length)
  {
    dw.runCommand("CFDS" + sourceName + ".htm")   
    if (MM.clickedOK) 
    {
      addValueToNote(siteURL, sourceName + "Count", sourceName, MM.retVal)
    } 
  }
  else
  {
    alert(MM.MSG_PleaseSaveSite)
  }
}

/* SITE WIDE HELPER FUNCTIONS END */


/* PAGE WIDE HELPER FUNCTIONS BEGIN */

function GetPageWideSourceDisplayNode(sourceName, nodeName, iconFileName, dataSource,name)
{
  var DSL = new Array()

  var dom = dw.getDocumentDOM()

  if (!dom)
  {
    return DSL
  }

  var bindingsArray = new Array()
  var fileURL = dom.URL

  if (!fileURL.length)
    fileURL = dwscripts.getTempURLForDesignNotes();

  if (fileURL.length)
  {
    getValuesFromNote(fileURL, bindingsArray, sourceName, sourceName + "Count")
    if (bindingsArray.length > 0)
    {
      DSL.push(new ObjectInfo(nodeName, iconFileName, false, dataSource,name))
    }
  }
  return DSL
}


function GetBindingsOfPageWideSource(sourceName, dataSource)
{
  var bindingsArray = new Array()
  var outArray = new Array
  var dom = dw.getDocumentDOM()
  var fileURL = dom.URL
  if (!fileURL.length)
    fileURL = dwscripts.getTempURLForDesignNotes();
  if (fileURL.length)
  {
    getValuesFromNote(fileURL, bindingsArray, sourceName, sourceName + "Count")
  }
  outArray = GenerateObjectInfoForSourceBindings(bindingsArray, datasourceleaf_filename, dataSource)

  return outArray 
}


function DeleteBindingOfPageWideSource(sourceName, bindingName)
{
  var fileURL = dw.getDocumentDOM().URL
  if (!fileURL.length)
    fileURL = dwscripts.getTempURLForDesignNotes();
  if (fileURL.length)
  {
    deleteValueFromNote(fileURL, sourceName + "Count", sourceName, bindingName)
  }
}


function SavePageWideValue(sourceName)
{
  var fileURL = dw.getDocumentDOM().URL
  if (!fileURL.length)
    fileURL = dwscripts.getTempURLForDesignNotes();
  if (fileURL.length)
  {
    dw.runCommand("CFDS" + sourceName + ".htm")   
    if (MM.clickedOK) 
    {
      //alert("about to add a note called: " + sourceName + " with a value of " + MM.retVal)
      addValueToNote(fileURL, sourceName + "Count", sourceName, MM.retVal)
    } 
  }
}

/* PAGE WIDE HELPER FUNCTIONS END */



function ObjectInfo(title, imageFile, allowDelete,dataSource,name)
{
  this.title = title;
  this.imageFile = imageFile;

  if (ObjectInfo.arguments.length >= 3)
  {
    this.allowDelete = allowDelete
  }
  else
  {
    this.allowDelete = true
  }

  if (ObjectInfo.arguments.length >= 4)
  {
    this.dataSource = dataSource
  }

  if (ObjectInfo.arguments.length >= 5)
  {
    this.name = name
  }
}


function GenerateObjectInfoForSourceBindings(oldArray, filename, dataSource)
{
  var outArray = new Array();
  for (var i = 0; i < oldArray.length; i++)
  {
    outArray[outArray.length] = new ObjectInfo(oldArray[i], filename, true, dataSource + ".htm","");
  }
  return outArray;
}

////////////////////////////////////////////////////////////////////////////////
//
//  Function: findNodebyName(elementName)
//
//  Returns a data source node by name.
////////////////////////////////////////////////////////////////////////////////
function findSourceNode(elementName)
{
  var foundnode = null;
  var currentdom = dreamweaver.getDocumentDOM();

  if (currentdom) {
  var nodes = currentdom.getElementsByTagName("CFQUERY");
  for (var index =0 ; index < nodes.length ; index++) {
    var node = nodes.item(index);
    if (node) {
      if(node.getAttribute("NAME") == elementName) {
        foundnode = node;
      }
    }
  }

  if (!foundnode){
    var nodes = currentdom.getElementsByTagName("CFSTOREDPROC")
    for (var i = 0; i < nodes.length; i++)  
    {
      var node = nodes[i]
      if(GetSPName(node) == elementName) 
      {
        foundnode = node;
      }
    }
  }

  if (!foundnode){
    var nodes = currentdom.getElementsByTagName("CFPROCRESULT");
    for (var index =0 ; index < nodes.length ; index++) {
      var node = nodes.item(index);
      if (node) {
        if(node.getAttribute("NAME") == elementName) {
          foundnode = node;
        }
      }
    }
  }
   }

  return foundnode;
}

function findSSrec(node,type)
{
  ssRecs = dw.serverBehaviorInspector.getServerBehaviors();
  ssMatchRec = null;
    for (var j=0; j<ssRecs.length; j++) { //search all ssRecs
      ssRec = ssRecs[j];
      if ((ssRec.participants)&&(ssRec.type == type)) {
        for (var k=0; k<ssRec.participants.length; k++) {    //scan ssRec participants
          if (ssRec.participants[k] == node){
      ssMatchRec = ssRec;
       } //check if node is participant, and increase refCount
        }
      }
    }
  return ssMatchRec;
}

function GetResultsetName(node)
{
  if (node.hasChildNodes())
  {
    for (var i = 0; i < node.childNodes.length; i ++)
    {
      var thisChild = node.childNodes[i]
      if (thisChild.tagName == "CFPROCRESULT")
      {
        return thisChild.getAttribute("NAME")
      }
    }
  }
  
  return ""
}


function GetSPName(node)
{
  var retVal = "mmerror"

  var inner = node.innerHTML
  var re = /<!---\s*mm_procname\s*=\s*"(\w+)"/i

  if (inner.search(re) != -1)
  {
    retVal = RegExp.$1
  }


  return retVal
}

function findSSrecByTitle(title,type)
{
  ssRecs = dw.serverBehaviorInspector.getServerBehaviors();
  ssMatchRec = null;
    for (var j=0; j<ssRecs.length; j++) { //search all ssRecs
      ssRec = ssRecs[j];
      if ((ssRec.participants)&&(ssRec.type == type)&&(ssRec.title == title)) {
      ssMatchRec = ssRec;
        }
      }
  return ssMatchRec;
}

function GetRecordsetNodeForCommand(node)
{
  var rnode = null;
  if (node.hasChildNodes())
  {
    for (var i = 0; i < node.childNodes.length; i ++)
    {
      var thisChild = node.childNodes[i]
      if (thisChild.tagName == "CFPROCRESULT")
      {
        rnode = thisChild;
        //Currently we support only one returned recordset.
        break;
      }
    }
  }
  
  return rnode;
}

////////////////////////////////////////////////////////////////////////////////
//
//  Function: inspectDynamicDataRef
//
//  Inspects a dynamic binding string and returns a pair of source and binding.
////////////////////////////////////////////////////////////////////////////////
function CFInspectDynamicDataRef(expression)
{
  var retArray = new Array()
  if(expression.length) 
  {
    // Quickly reject if the expression doesn't contain "<cfouput>"
    var exprIndex = expression.indexOf("#");
    if (exprIndex != -1)
    {
      // No need to search the string prior to the "<cfoutput>"
      expression = "<cfoutput>"+expression.substr(exprIndex)+"</cfoutput>";

      var TranslatorDOM = dreamweaver.getDocumentDOM(dreamweaver.getConfigurationPath() + "/Translators/UD4-ColdFusion.htm");
      if (TranslatorDOM)  
      { 
        TranslatedStr = TranslatorDOM.parentWindow.miniTranslateMarkup("", "", expression, false);        
        if (TranslatedStr.length)
        {
          var found = TranslatedStr.search(/mm_dynamic_content\s+source="?(\w+)"?\s+binding="?(\w[\w\.]*)"?/i)
          if (found != -1)
          {
            retArray[0] = RegExp.$1
            retArray[1] = RegExp.$2         
          }
        }
      }
    }
  }
    
  return retArray;
}
