<%@ Control Language="C#" debug="true" WarningLevel="4" %>

<script runat="server">

public Boolean PostBackBind = true;
public Boolean Ignore = false;
private Boolean MustDoBind = true;

static System.Web.UI.WebControls.DataGrid theDataGrid = new System.Web.UI.WebControls.DataGrid();

protected void Page_DataBind(Object Src, EventArgs E)
{
	MustDoBind = false;
}

protected void Page_Load(Object Src, EventArgs E)
{
	if (!Ignore)
	{
		// We don't want to bind if this is the result of clicking
		// on a DataGrid editCommand or delete button.
		// The buttons can be links or push buttons. Unfortunately,
		// they work differently.

		// Detect the hyperlink case...

		String eventTarget = Request.Form["__EVENTTARGET"];

		if (eventTarget != null)
		{
			int index = eventTarget.IndexOf(":");

			if (index >= 0)
			{
				eventTarget = eventTarget.Substring(0, index);

				Object ctrl = Page.FindControl(eventTarget);
				
				if (ctrl != null)
				{
					if (ctrl.GetType() == theDataGrid.GetType())
					{
						Ignore = true;
					}
				}
			}
		}
	
	}
	
	if (!Ignore)
	{			
		// Detect the pushbutton case...
		//
		// We need to figure out which button submitted the form and
		// then figure out if that button belongs to a DataGrid.
		
		String[] formCtrlNames = Request.Form.AllKeys;
		
		for (int index = 0; index < formCtrlNames.Length; index++) 
		{
			String name = formCtrlNames[index];

			// The buttons we're interested in will have names like...
			// DataGrid1:_ctl12:_ctl0, so look for something like that
			
			int strIndex = name.IndexOf(":_ctl");
			
			if (strIndex == (-1))
				continue;

			// See if it has a value
			
			if (Request.Form[name] == null)
				continue;
				
			// The first part of the name is the parent control
			// See if it's a DataGrid
			
			name = name.Substring(0, strIndex);

			Object ctrl = Page.FindControl(name);
			
			if (ctrl != null)
			{
				if (ctrl.GetType() == theDataGrid.GetType())
				{
					Ignore = true;
					break;
				}
			}
		}
	}

	if (MustDoBind && (!Ignore))
	{
		if ((!Page.IsPostBack) || (PostBackBind))
		{
			Parent.DataBind();
		}
	}
}

</script>

