/*
CFQueryShared.js
------------------------------------------------------
Copyright 2001 Macromedia, Inc. All rights reserved.

This file is shared by the PI and Init Dialogs of the
CFQuery object.

*/

/******* GLOBAL VARIABLES BEGIN ********************/

// This array is intialized in InitializeList.
// It is used several times while finding server behaviors.

var paramTags




var CONST_TYPE = "cfquery"

var WGHT_CFQuerySet = 40
var WGHT_CFQueryDefault = 45
var WGHT_CFQuery = 50
var WGHT_StatsChunk = 55

var DEBUG = false


//var CFQueryMask = "<cfquery name=\"#name#\" datasource=\"#dataSource#\" #usrpwd#>" +
var CFQueryMask = "<cfquery name=\"#name#\" datasource=\"#dataSource#\" #usrpwd# #maxrows#>" +
					"#sql#" +
					"</cfquery>"

/* Example code

<CFPARAM NAME="state" DEFAULT="CA">
<CFPARAM NAME="CFQUERY1__sp" DEFAULT="#state#">

*/

//the following node is referred to as the "set node"
var CFSetMask = "<cfparam name=\"#runtimeVal#\" default=\"#defaultVal#\">"

//the following node is referred to as the "param node"
var CFParamMask = "<cfparam name=\"#varname#\" default=\"##runtimeVal##\">"

var StatsMask = "<cfset #name#_NumRows = 0>\n<cfset #name#_Index = 1>"

var gMainNodeSource = ""  // Used to select the node after updating and inserting


/******* GLOBAL VARIABLES END ********************/



/******* CUSTOM OBJECT DEFINITIONS BEGIN ********************/


/*
queryRec is a superset of ssRecord.  It is the main data structure that holds
information about the stored proc.  This data structure can be filled out in
its entirety by findServerBehaviors() (which gets all the info from the DOM of
the current page) and it can be filled out partially by GetDataFromUI() (which,
obviously, gets the data from the UI.  Of course the node ptrs will still be
null.)

This data structure acts as the "middle man" for most of the functionality
encapsulated in this file.  This way, knowledge of the "UI to DOM" structure does
not have to be "known" by multiple routines. 
*/


function queryRec()  // a superset of ssRec
{
	var theRec = new SSRecord()
	theRec.name = ""
	theRec.connectionName = ""
	theRec.username = ""
	theRec.password = ""
	theRec.sql = ""
	theRec.paramArray = new Array()
	theRec.indexNode = null
	theRec.numRowsNode = null
	theRec.maxRows = null
	

	theRec.message = ""				// if incomplete flag set, this would have a message to display
	theRec.severity = ""			// indicates whether or not the incomplete, or erred, object can be
									// remedied automatically. "ok" means yes, "abort" means no

	return theRec	
}



/*
paramObj's are used to keep info about each parameter of a CFQUERY.
An array of paramObj's can be found at queryRec.paramArray.
*/

function paramObj()
{
	this.name = ""			
	this.defaultVal = ""	// The value entered by the user in the "Default Value" column of the param grid
	this.runtimeVal = ""	// The value entered by the user in the "Runtime Value" column of the param grid
							// Currently the user is forced to put #'s around this val, but the #'s are stripped
							// before being saved in this property.							
		
	this.setNode = null		// Pointer to the node that has a name attr of "<runtime val>" where <runtime val>
							// is retrieved from the "default" attr of the paramNode.
	this.paramNode = null	// Pointer to the node that has a name attr of "<cfqueryname>__<paramName>"
}


/*******  CUSTOM OBJECT DEFINITIONS END ********************/



function UpdateCFQueryInDOM(uiData, priorRec)
{
	var editList = buildSSEdits(uiData)

	// We want to replace all the existing chunks with nothing

	for (var i = 0; i < priorRec.participants.length; i++)
	{
		editList.add("", priorRec.participants[i], "replaceNode")
	}

  editList.insert(true);
}


function InsertMe(uiData)
{
	var editList = buildSSEdits(uiData)
  editList.insert();
}


function buildSSEdits(valueNode)
{
	var editList = new SSEdits()

	//We need to encode the sql statement if there are parameters.
	var strSQL = String(valueNode.sql)

	for (var i = 0; i < valueNode.paramArray.length; i++)
	{
		//traceString("creating code for param " + i) 
		var thisParam = valueNode.paramArray[i]
		CreateParamChunk(valueNode.name, thisParam, editList)

		var paramRE = new RegExp("\\b" + thisParam.name + "\\b", "g")
		strSQL = strSQL.replace(paramRE, "#" + valueNode.name + "__" + thisParam.name + "#")
	}

	var chunk = CFQueryMask
	chunk = chunk.replace(/#name#/g,valueNode.name)
	chunk = chunk.replace(/#dataSource#/g,MMDB.getDeployConnectionString(valueNode.connectionName))
	chunk = chunk.replace(/#sql#/g, strSQL)

	var userName = MMDB.getUserName(valueNode.connectionName)
	var password = MMDB.getPassword(valueNode.connectionName)

	if (userName || password)
	{
		chunk = chunk.replace(/#usrpwd#/g,"username=\"" + userName + "\" password=\"" + password + "\"")
	}
	else
	{
		chunk = chunk.replace(/#usrpwd#/g,"")
	}

	if(valueNode.maxRows)
	{
		chunk = chunk.replace(/#maxrows#/g, "maxrows=" + valueNode.maxRows)
	}
	else
	{
		chunk = chunk.replace(/#maxrows#/g, "")
	}

	editList.add(chunk,null,WGHT_CFQuery)

	gMainNodeSource = chunk

	var chunk= StatsMask
	chunk = chunk.replace(/#name#/g, valueNode.name)
	//alert("adding this chunk to editList: " + chunk)
	editList.add(chunk, null, WGHT_StatsChunk)
	
	return editList
}


function CreateParamChunk(rsName, thisParam, editList)
{
	var runtimeVal = ""
	var chunk = CFSetMask
	chunk = chunk.replace("#defaultVal#", thisParam.defaultVal)

	var found = thisParam.runtimeVal.search(/^#(.+)#$/)
	if (found == -1)
	{
		runtimeVal = thisParam.runtimeVal
	}
	else
	{
		runtimeVal = RegExp.$1
	}

	chunk = chunk.replace("#runtimeVal#", runtimeVal)
	editList.add(chunk,null,WGHT_CFQuerySet)
	
	chunk = CFParamMask
	chunk = chunk.replace("#varname#", rsName + "__" + thisParam.name)
	chunk = chunk.replace("#runtimeVal#", runtimeVal)
	editList.add(chunk,null,WGHT_CFQueryDefault)
}
