/*
CFStoredProc.js
---------------------------------------------------
Copyright 2001-2002 Macromedia, Inc. All rights reserved.
*/

var helpDoc = MM.HELP_ssUD4CFStoredProc

var FOR_TEST = 1
var FINAL = 2


// These two arrays are intialized in InitializeList.
// They are used several times while finding server behaviors.

var paramTags 
var setTags

/*******  SSI API CALLS BEGIN ******************************/


function findServerBehaviors()
{
  InitializeLists()   
  var ssRec
  var ssRecList = new Array()
  var dom = dw.getDocumentDOM()

  var nodes = dom.getElementsByTagName("CFSTOREDPROC")

  for (var i = 0; i < nodes.length; i++) 
  {
    ssRec = buildSSRecord(nodes[i])
    if (ssRec)
    {     
      ssRecList.push(ssRec)
    }
  }

  return ssRecList
}


function applyServerBehavior(priorRec) 
{
  var errMsg = CheckData(FINAL, priorRec) 

  if (errMsg != "")
  {
    return errMsg
  }

  var retVal = ""

  var uiData = GetDataFromUI()

  if (priorRec)
  { 
    UpdateCFStoredProcInDOM(uiData, priorRec)
  }
  else
  {
    // This is the first time we are inserting
    InsertMe(uiData)
  }

  //refresh the cache for cfstoreproc.
  MMDB.refreshCache(true);

  return retVal
}


function inspectServerBehavior(ssRec) 
{ 

  CFSTOREDPROC_TEXT.value = ssRec.procedure
  CD_NAME_BOX.value = ssRec.name
  CONN_LIST.pickValue(ssRec.connectionName)
  TREE.setConnection(ssRec.connectionName)

  if (ssRec.resultNode)
  {
    RR_CHECKBOX.checked = true
    RR_NAME.value = ssRec.resultsetName
  }

  var delim = ","
  var list = PARAM_LIST

  if (ssRec.paramArray)
  {
    contentArray = new Array()

    for (var i = 0; i < ssRec.paramArray.length; i++)
    {
      var thisDOMParam = ssRec.paramArray[i]
      var thisGridParam = new Array
      var thisType = GetDirStringFromCFType(thisDOMParam.type)

    
      thisGridParam[0] = thisDOMParam.dbName
      thisGridParam[1] = thisDOMParam.cfSQLType
      thisGridParam[2] = thisType

      if (thisType == "out")
      {
        thisGridParam[3] = ""
        thisGridParam[4] = ""
      }
      else
      {     
        thisGridParam[3] = thisDOMParam.defaultVal
        thisGridParam[4] = "#" + thisDOMParam.runtimeVal + "#"
      }

      contentArray.push(thisGridParam)
    }

    PARAM_LIST.setContents(contentArray)
    PARAM_LIST.setIndex(0)
  }

  checkBoxClicked() //updates the test button

  if (ssRec.outOfDate) {
    alert(MM.MSG_SBOutOfDate);
  }
  if (ssRec && ssRec.errorMsg) {
    alert(ssRec.errorMsg);
  }

}


function deleteServerBehavior(ssRec) 
{
  ssRec.del()
  //DeleteChunks(ssRec.participants)

  //refresh the cache for cfstoreproc.
  removeCachedSchemaInfo(ssRec.name);
  if (ssRec.resultsetName)
  {
    removeCachedSchemaInfo(ssRec.resultsetName);
  }
  MMDB.refreshCache(true);
  return true
}


/*******  SSI API CALLS END ********************************/


/*******  SEVER MODEL API BEGIN ****************************/

function getDynamicBindings(elementNode)
{
  var parametersArray = new Array()
  var columnsArray = new Array()

  if (elementNode.tagName == "CFSTOREDPROC")
  {
  //alert("it was a cfstoredproc")
    var ss = findSSrec(elementNode, CONST_TYPE)

    //First we construct an array of the return value and out/(in/out) parameters
    for (var i = 0; i < ss.paramArray.length; i++)
    {
      var dir = ss.paramArray[i].type 
      if (dir == "out" || dir == "inout")
      {
        parametersArray.push(ss.paramArray[i].name)
      }
    }
    
    parametersArray.push("RETURN_VALUE")    
  }
  else if (elementNode.tagName == "CFPROCRESULT")
  {
    //alert("it was cfprocresult")

    var ss = findSSrec(elementNode.parentNode, CONST_TYPE)

    var connName = ss.connectionName
    var comName = ss.name
    
    if (ss.paramArray.length > 0)
    {
      var pa = ss.paramArray

      var paramNames = new Array()
      var paramValues = new Array()
      
      for (var i = 0; i < pa.length; i++)
      {
        var aParam = pa[i]
        paramNames[i] = aParam.dbName
        paramValues[i] = aParam.defaultVal
      }

      strOut = "Proc Name: " + ss.procedure + "\n"
      for (var i = 0; i < paramNames.length; i++)
      {
        strOut += "\nParam " + i + "\n  name:" + paramNames[i]
        strOut += "\n  value: " + paramValues[i]
      }

      //alert(strOut)

      columnsArray = MMDB.getSPColumnListNamedParams(connName, ss.procedure, paramNames, paramValues,true)
    }
    else
    {
      var noParams = new Array()
      columnsArray = MMDB.getSPColumnList(connName, ss.procedure, noParams,true)
    }
  }

  var outArray = new Array()

  for (var i = 0; i < parametersArray.length; i++)
  {
    outArray.push(parametersArray[i])
  } 

  for (var i = 0; i < columnsArray.length; i++)
  {
    outArray.push(columnsArray[i])
  } 

  return outArray
}


/*******  SEVER MODEL API END ******************************/


function ClearUI()
{
  CFSTOREDPROC_TEXT.value = ""
  CD_NAME_BOX.value = ""
}


function InitializeLists()
{
  var dom = dw.getDocumentDOM()

  // paramTags and setTags are global variables

  paramTags = dom.getElementsByTagName("CFPARAM")
  setTags = dom.getElementsByTagName("CFSET")
}


function getConnectionName(dataSource, theRec)
{  
  // We need to find the correct UltraDev connection based on
  // the dataSource, and username and password.
  var username = theRec.username?theRec.username:"";
  var password = theRec.password?theRec.password:"";

  // Passing the DSN as the connection string is a legacy hack that I hope
  // to get rid of someday rje 01Sep00
//return MMDB.getConnectionName("", "", dataSource, username, password);

  var ConnName = MMDB.getConnectionName(dataSource, "", dataSource, username, password);
  if (!ConnName.length)
  {
  dataSourceLong = "dsn=" + dataSource + ";uid=" + username + ";pwd=" + password;
  ConnName = MMDB.getConnectionName(dataSourceLong, "", dataSource, username, password);
  }

  return ConnName;
}

function buildSSRecord(node) 
{
  var theName = GetNameFromDom(node)
  ssRec = spRec() //don't use "new"
  ssRec.type = CONST_TYPE
  ssRec.title = MM.LABEL_TitleStoredProc + " (" + theName + ")"
  ssRec.name = theName
  ssRec.username = node.getAttribute("username")
  ssRec.password = node.getAttribute("password")
  
  //check if this is a new connection
  var dataSource = node.getAttribute("datasource");
  var match = dataSource.match(/MM_(\w+)_DSN/);
  if (match && match.length > 0) {
    ssRec.connectionName = match[1];
  } else {    
    ssRec.connectionName  = getConnectionName(node.getAttribute("datasource"), ssRec);
    ssRec.outOfDate = true;
    ssRec.title += MM.LABEL_OutOfDate;
  }
    
  ssRec.selectedNode = node
  ssRec.weights.push(WGHT_CFStoredProc)
  ssRec.participants.push(node)
  ssRec.types.push("storedproc_main");
  ssRec.procedure = node.getAttribute("procedure")
  GetParamsFromDom(ssRec)
  
  AnalyzeRec(ssRec)

  if (!ssRec.outOfDate) {
    //look for the connection statement
    var found = false;
    var part = new Participant("connectionref_statement");
    //NOTE: dw.getParticipants will only find participants that are
    //      part of a server behavior group file whose find is triggered.
    //      We can use this call here, because the search patterns for
    //      recordset will be triggered by the CFStoredProc runtime code.
    var partList = dw.getParticipants("connectionref_statement");
    for (var i=0; partList && i < partList.length; i++) {
      if (partList[i].parameters.cname == ssRec.connectionName) {
        //add this part to the ssRec
        ssRec.participants.push(partList[i].participantNode);
        ssRec.weights.push(part.location);
        ssRec.types.push(part.name);
        ssRec.parameters = new Object();
        ssRec.parameters.cname = partList[i].parameters.cname;
        ssRec.parameters.relpath = partList[i].parameters.relpath;
        ssRec.parameters.ext = partList[i].parameters.ext;

        //check if the path is correct, if the file is saved
        var dom = dw.getDocumentDOM();
        if (dom && dom.URL && partList[i].parameters.relpath != getConnectionsPath(partList[i].parameters.cname)) {
          ssRec.incomplete = true;
          ssRec.errorMsg += "\n"+MM.MSG_ConnectionPathInvalid;
        }

        found = true;
        break;
      }
    }
    if (!found) ssRec.incomplete = true;
  }

  return ssRec
}


function GetParamsFromDom(ssRec)
{
  var theName = ssRec.name
  var i
  var theArray = new Array()
  var paramNode

  if (ssRec.selectedNode.hasChildNodes())
  {
    var childNodes = ssRec.selectedNode.childNodes
  }
  else
  {
    ssRec.paramArray = theArray
    return
  }

  // First get an array of parameter objects
  for (i = 0; i < childNodes.length; i++)
  {
    var thisChild = childNodes[i]
    if (thisChild.tagName && thisChild.tagName == "CFPROCPARAM")
    {
      paramNode = new paramObj()
      paramNode.dbName = thisChild.getAttribute("dbvarname")
      paramNode.name = StripChars("@", paramNode.dbName)
      paramNode.type = thisChild.getAttribute("type").toLowerCase()
      paramNode.cfSQLType = thisChild.getAttribute("cfsqltype").toUpperCase()
      paramNode.cfNode = thisChild
      if (paramNode.type == "in" || paramNode.type == "inout")
      {
        FindInitNodes(ssRec, paramNode)
      }
      theArray.push(paramNode)
    }
    else if (thisChild.tagName == "CFPROCRESULT")
    {
      ssRec.resultNode = thisChild
      ssRec.resultsetName = thisChild.getAttribute("name")
    }
  }

  ssRec.paramArray = theArray

  // Now find the CFSET tag that holds the return value
  
  for (i = 0; i < setTags.length; i ++)
  {
    var thisTag = setTags[i]
    var tagText = thisTag.outerHTML
    var re = RegExp("<\\s*cfset\\s*" + ssRec.name + "__RETURN_VALUE" + "\\s*=", "i")
    var index = tagText.search(re)
    if (index > -1)
    {
      ssRec.returnValueNode = thisTag
      ssRec.participants.push(thisTag)
      ssRec.weights.push(WGHT_CFStoredProcRetVal)
      ssRec.types.push("storedproc_retval");
      break
    }
  }
}


function FindInitNodes(ssRec, paramNode)
{
  var theName = ssRec.name

  // Given a CFPROCPARAM node of type "in" or "inout", find the two CFPARAM nodes
  // that correspond to that node.

  //First find the "param" node which we know the name of: #spname#__#paramname#

  var paramTagName = ssRec.name + "__" + paramNode.name

  // paramTags is a global variable

  for (var i = 0; i < paramTags.length; i++)
  {
    var theTag = paramTags[i]
    var theTagName = theTag.getAttribute("name")
    
    if (theTagName != paramTagName)
    {
      continue
    }
    
    var paramRuntimeVal = theTag.getAttribute("default")

    //strip the pound signs
    index = paramRuntimeVal.search(/#(.+)#/)
    if (index == -1)
    {
      continue
    }
    paramRuntimeVal = paramRuntimeVal.replace(/#.+#/, RegExp.$1)

    var varName = theTagName
    paramNode.runtimeVal = paramRuntimeVal
    paramNode.paramNode = theTag
    paramNode.setNode = null
    ssRec.participants.push(theTag) 
    ssRec.weights.push(WGHT_CFStoredProcDefault)
    ssRec.types.push("storedproc_defaultval");

    // now find the CFPARAM tag that provides our default value
    for (var j = 0; j < paramTags.length; j++)
    {
      var thisParam = paramTags[j]
      if (thisParam.getAttribute("name") == paramNode.runtimeVal)
      {
        paramNode.defaultVal = thisParam.getAttribute("default")
        paramNode.setNode = thisParam
        ssRec.participants.push(thisParam)
        ssRec.weights.push(WGHT_CFStoredProcSet)
        ssRec.types.push("storedproc_runtimeval");
        break
      }
    }
  }
}


function AnalyzeRec(ssRec)
{
  // We should probably do a lot more checks here??

  // We want to make sure that all of the nodes
  // are present and in the right top to bottom
  // order.

  
  for (var i = 0; i < ssRec.paramArray.length; i++)
  {
    var thisParam = ssRec.paramArray[i]

    if (thisParam.type == "out")
    {
      continue
    }

    if (thisParam.setNode == null)
    {
      ssRec.message = "The set node is missing for parameter: '" + thisParam.name + "'.\n\nUltraDev cannot resolve this.  Do it by hand."
      ssRec.incomplete = true
      ssRec.severity = "abort"
      return
    }

    if (thisParam.paramNode == null)
    {
      ssRec.message = "The param node is missing for parameter: '" + thisParam.name + "'.\n\nUltraDev cannot resolve this.  Do it by hand."
      ssRec.incomplete = true
      ssRec.severity = "abort"
      return
    }

  }

  if (ssRec.returnValueNode == null)
  {
    ssRec.message = "The ret val node is missing for this Stored Proc.\n\nUltraDev cannot resolve this.  Please delete and reinsert this Stored Proc."
    ssRec.incomplete = true
    ssRec.severity = "abort"
    return
  }

}


function GetNameFromDom(node)
{
  var retVal = "mmerror"

  var inner = node.innerHTML
  var re = /<!---\s*mm_procname\s*=\s*"(\w+)"/i

  if (inner.search(re) != -1)
  {
    retVal = RegExp.$1
  }

  return retVal
}




function GetDataSource()
{
  return CONN_LIST.getValue()
}


function GetProcedure()
{
  return Trim(CFSTOREDPROC_TEXT.value)
}


function GetDataFromUI()
{
  var rec = spRec() //don't use "new"
  rec.name = GetName()
  rec.connectionName = GetDataSource()
  rec.procedure = GetProcedure()
  if (RR_CHECKBOX.checked)
  {
    rec.resultsetName = RR_NAME.value
  }

  var paramArray = GetParamArray()

  for (var i = 0; i < paramArray.length; i++)
  {
    var thisParam = paramArray[i]
    var newParam = new paramObj()
    newParam.dbName = thisParam[0]
    newParam.name = StripChars("@", thisParam[0])
    newParam.cfSQLType = thisParam[1].toUpperCase()
    newParam.type = thisParam[2]  //direction
    switch (newParam.type)
    {
      case 1:
        newParam.type = "in"
        break
      case 2:
        newParam.type = "out"
        break
      case 3:
        newParam.type = "inout"
        break
      case 4:
        newParam.type = "return"
        break
    }

    newParam.defaultVal = thisParam[3]
    newParam.runtimeVal = thisParam[4]
    // strip the pound signs
    newParam.runtimeVal = newParam.runtimeVal.substring(1, newParam.runtimeVal.length - 1)
    rec.paramArray.push(newParam)
  }

  return rec
}


function checkBoxClicked()
{
  if (RR_CHECKBOX.checked)
  {
    TEST_BUTTON.removeAttribute("disabled");
  }
  else
  {
    TEST_BUTTON.setAttribute("disabled", true);
  }
}


//This function returns a Connection Object with ConnectionProperties
function getConnectionString(connectionName)
{
  return "\""+ MMDB.getConnectionString(connectionName) + "\""
}


function GetDirStringFromCFType(str)
{
  var a = new Array()

  a["in"] = "in"
  a["out"] = "out"
  a["inout"] = "in/out"
  a["return"] = "RETURN_VALUE"

  if (!a[str])
    alert(errMsg(MM.MSG_DirStringFromCFType,str));

  return a[str]
}

function GetDirString(dirNum)
{
  var a = new Array()

  a[1] = "in"
  a[2] = "out"
  a[3] = "in/out"
  a[4] = "RETURN_VALUE"

  if (!a[dirNum])
    alert(errMsg(MM.MSG_DirString,dirNum));

  return a[dirNum]
}


function GetDirNum(dirString)
{
  var a = new Array()

  a["in"] = 1
  a["out"] = 2
  a["in/out"] = 3
  a["RETURN_VALUE"] = 4
  
  if (!a[dirString])
    alert(errMsg(MM.MSG_DirNum,dirString));

  return a[dirString]
}


function CheckData(reason, priorRec)
{
  /*
  This function checks all of the input variables to see
  if the user has filled out everything okay...if not
  return an error string.  If so, return empty string
  */

  var strOut = ""


  if (reason == FINAL)
  {
    // we don't get here if we are just testing the statement
    var theName = Trim(CD_NAME_BOX.value)
    if (theName == "")
    {
      strOut += MM.MSG_NoStoredProcName;
      return strOut
    }

    if (!IsValidVarName(theName))
    {
      strOut = MM.MSG_InvalidStoredProcName;
      return strOut
    }

    if (IsDupeObjectName(theName, priorRec?priorRec.name:""))
    {
       return MM.MSG_DupeStoredProcName
    }
  }

  if (CONN_LIST.getIndex() == 0)
  {
    strOut += MM.MSG_NoConnection
    return strOut
  }
  

  if (RR_CHECKBOX.checked)
  {

    if (reason == FINAL)
    {
      var rsName = RR_NAME.value
      if (StripChars(" \t\r\n", rsName) == "")
      {
        return MM.MSG_NoRecordsetName
      }
      
        if (!IsValidVarName(rsName))
      {
        strOut = MM.MSG_InvalidRecordsetName
        return strOut
      }


      var prevName = "";
      if (priorRec && priorRec.resultsetName)
      {
        prevName = priorRec.resultsetName
      }
  
      if (IsDupeObjectName(rsName, prevName))
      {
        return MM.MSG_DupeRecordsetName
      }
    }
  }

  var theSQL =  CFSTOREDPROC_TEXT.value
  if (StripChars(" \r\n\t", theSQL) == "")
  {
    strOut += MM.MSG_NoStoredProcText;
    return strOut
  }

  var pa = PARAM_LIST.getContents()
  if (pa.length > 0)
  {   
    strOut = CheckSPParams(pa, reason)
  }

  return strOut
}


function CheckSPParams(pa, reason)
{
  var strOut = ""

  for (var i = 0; i < pa.length; i++)
  {
    var anOption = pa[i]
    var theType = GetDirNum(anOption[2])

    var theName = Trim(anOption[0])
    if (theName == "")
    {
      strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + MM.MSG_MissingParamName
      return strOut
    }

    var theCFSQLType = Trim(anOption[1]).toUpperCase()
    if (theCFSQLType == "")
    {
      strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + 
        MM.MSG_MissingCFSQLType + theName + "\n\n" + MM.MSG_NeedCFSQLType + "\n" + strCFSQLTypeList

      return strOut
    }

    if (theType != 2 && strCFSQLTypeList.indexOf("\n" + theCFSQLType + " ") == -1)
    {
      strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + 
        MM.MSG_InvalidCFSQLType + theName + "\n" + MM.MSG_NeedCFSQLType + "\n" + strCFSQLTypeList

      return strOut
    }


    var theDefaultVal = Trim(anOption[3])
    if (theDefaultVal == "" && (theType == 1 || theType == 3))
    {
      strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + MM.MSG_DefaultValMissing + theName
      return strOut
    }

    if (reason == FINAL)
    {
      var theRunTimeVal = Trim(anOption[4])
      if (theRunTimeVal == "" && (theType == 1 || theType == 3))
      {
        strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + MM.MSG_RunTimeValMissing + theName
        return strOut
      }
      else
      {
        if (theType != 2 && (theRunTimeVal.charAt(0) != "#" || theRunTimeVal.charAt(theRunTimeVal.length - 1) != "#"))
        {
          strOut = MM.LABEL_StoredProcParamRow + (i + 1) + "\n\n" + MM.MSG_InvalidRunTimeVal + theName
          return strOut
        }
      }
    } 
  }

  return ""
}


function GetName()
{
  /*
  Returns the name the user entered in the form
  */
  return Trim(CD_NAME_BOX.value)
}


function GetUsername()
{
  /*
  Returns the username the user provided in the
  form.
  */

  return Trim(findObject("userName").value)
}


function GetPassword()
{
  /*
  Returns the password the user provided in the
  form
  */

  return Trim(findObject("password").value)
}


function GetCFStoredProcText(cdName,ParamArray,theCFStoredProcType)
{

   var ServerBehaviorLanguage = site.ServerModel.getServerLanguage()

  var theSQL = CFSTOREDPROC_TEXT.value
  if (ServerBehaviorLanguage == "JavaScript")
  {
    theSQL = theSQL.replace(/\n/g,"\\n")
    theSQL = theSQL.replace(/\r/g,"\\r")
  }
  else
  {
    theSQL = theSQL.replace(/\r/g,"\" + Chr(13) + Chr(10) + \"")
    theSQL = theSQL.replace(/\n/g,"")
  }

  if ((theCFStoredProcType == 4) || (ParamArray.length == 0))
  {
    return "\"" + theSQL + "\""
  }


  //there were params
  for (i = 0; i < ParamArray.length; i++)
  {
    var ParamName = ParamArray[i][0]
    var ParamRe = new RegExp("\\b" + ParamName + "\\b","ig")

    if (site.ServerModel.getServerLanguage() == "JavaScript")
    {
      var sqlparam = MASK_AspSQLJSParam
      sqlparam = sqlparam.replace(/##cdname##/g,cdName)
      sqlparam = sqlparam.replace(/##pname##/g,ParamName)
      theSQL = theSQL.replace(ParamRe,sqlparam)
    }
    else
    {
      var sqlparam = MASK_AspSQLVBParam
      sqlparam = sqlparam.replace(/##cdname##/g,cdName)
      sqlparam = sqlparam.replace(/##pname##/g,ParamName)
      theSQL = theSQL.replace(ParamRe,sqlparam)
    }
  }


  return "\"" + theSQL + "\""
}


function GetParamArray()
{
  var paramArray = PARAM_LIST.getContents()

  // convert direction string to a number
  for (var i = 0; i < paramArray.length; i++)
  {
    paramArray[i][2] = GetDirNum(paramArray[i][2])
  }
  
  return paramArray
}


function PopulateConnectionList()
{
  var oldConn = CONN_LIST.getValue()

  var connList = MMDB.getConnectionList()

  var wholeList = new Array()

  wholeList.push(MM.LABEL_None)
  for (var i = 0; i < connList.length; i++)
  {
    wholeList.push(connList[i])
  }

  CONN_LIST.setAll(wholeList, wholeList)
  CONN_LIST.setValue(MM.LABEL_None, 0)

  var index = CONN_LIST.getIndex(oldConn)

  if (!CONN_LIST.pickValue(oldConn)) 
  {
    if (CONN_LIST.getLen() == 2) 
    { 
      CONN_LIST.setIndex(1)
      ConnectionChanged()
    }
    else
    {
      CONN_LIST.setIndex(0)
    }
  }
  else
  {
    //the database tree ctrl could be populated
    //already... so, it needs to be refreshed. The tree control will not 
    //refresh itself if the connection passed in is the same, so set it 
    //to a dummy value and then re-set the original connection. This will
    //force it to update the meta-data.
    TREE.setConnection("");
    TREE.setConnection(oldConn);
  }

}


function initializeUI()
{
  /*
  This function is called in the onLoad event.  It is responsible
  for initializing the UI.  If we are inserting a recordset, this
  is a matter of populating the connection drop down.

  If we are modifying a recordset, this is a matter of inspecting
  the recordset tag and setting all the form elements.
  */

  //Create global vars for all controls
  CONN_LIST   = new ListControl("ConnectionList")
  PARAM_LIST    = new GridControl("ParamList")
  CFSTOREDPROC_TEXT = findObject("theCFStoredProcText")
  CD_NAME_BOX   = findObject("CFStoredProcName")
  MINUS_BUTTON  = findObject("minusButton")
  PLUS_BUTTON   = findObject("plusButton")
  TREE      = new DBTreeControl("DBTree")
  RR_CHECKBOX   = findObject("RResultset")
  RR_NAME     = findObject("RResultsetName")
  TEST_BUTTON   = findObject("testButton")

  PopulateConnectionList()
  CD_NAME_BOX.value = CreateNewName()
  checkBoxClicked();
}


function CreateNewName()
{
  var num = 0
  var dom = dw.getDocumentDOM()
  var nodes = dom.getElementsByTagName("CFSTOREDPROC")
  var newNameFound = false

  while (!newNameFound)
  {
    num++
    var comName = "CFStoredProc" + num
    for (var i = 0; i < nodes.length; i++)
    {
      var theName = (GetSPName(nodes[i]))
      if (theName.toLowerCase() == comName.toLowerCase())
      {
        break
      }
    }

    if (i == nodes.length)
    {
      newNameFound = true
    }
  }

  return comName
}


function GetSPName(node)
{
  var retVal = "mmerror"

  var inner = node.innerHTML
  var re = /<!---\s*mm_procname\s*=\s*"(\w+)"/i

  if (inner.search(re) != -1)
  {
    retVal = RegExp.$1
  }


  return retVal
}

function DeleteParam()
{
  /*
  This function is called when the user
  clicks on the minus button above the params list box.
  If there is not a selected index in the list, we do
  nothing. 
  */

  PARAM_LIST.del()
  //UpdateMinusButton()
}


function AddParam()
{
  //PARAM_LIST.append()
  //UpdateMinusButton()
  if (dw.isOSX())
  {
    // work around a problem in OSX where the first editable
    // region does not get focus.  Add a defaut name
    // so the user can see that something happened
    PARAM_LIST.object.options.push(new Option(MM.LABEL_Unnamed))
  }
  else
  {
    PARAM_LIST.object.options.push(new Option(""))
  }
}


function UpdateMinusButton()
{
  if (PARAM_LIST.getIndex() >= 0)
  {
    MINUS_BUTTON.src = "../../Shared/UltraDev/Images/MinusButtonEnabled.gif"
  }
  else
  {
    MINUS_BUTTON.src = "../../Shared/UltraDev/Images/MinusButtonDisabled.gif"
  }
}


function ReplaceParamsWithVals(st, pa, valCol)
{
  var statement = st
  for (var i = 0; i < pa.length; i++)
  {
    var myRe = new RegExp("\\b" + pa[i][0] + "\\b","g")
    statement = statement.replace(myRe, pa[i][valCol])
  }
  return statement
}


function PopUpTestDialog()
{
  var msg = CheckData(FOR_TEST)
  if (msg != "")
  {
    alert(msg)
    return
  }

  var pa = PARAM_LIST.getContents()
  var paramNames = new Array()
  var paramValues = new Array()
  
  for (var i = 0; i < pa.length; i++)
  {
    var aParam = pa[i]
    paramNames[i] = aParam[0]
    var aVal = aParam[3]
    if ((aVal.charAt(0) == '"' && aVal.charAt(aVal.length - 1) == '"') ||  
      (aVal.charAt(0) == "'" && aVal.charAt(aVal.length - 1) == "'"))
    {
      aVal = aVal.substring(1,aVal.length - 1)
    }
    paramValues[i] = aVal
  }

  var proc = Trim(CFSTOREDPROC_TEXT.value)

  MMDB.showSPResultsetNamedParams(CONN_LIST.getValue(), proc, paramNames, paramValues)
}


function ConnectionChanged()
{
  TREE.setConnection(CONN_LIST.getValue())
}


function AppendToSQL()
{
  var treeData = TREE.getData()
  
  if (!treeData.IsProcedure())
  {
    return
  }

  // Auto-populate the param grid

  PARAM_LIST.delAll()

  var gridArray = new Array()

  var typeMessage = false

  for (var i = 0; i < treeData.paramArray.length; i++)
  {
    var thisRow = new Array()
    var thisParam = treeData.paramArray[i]

    var theDir = GetDirString(thisParam.direction)
    var theSQLType = getSQLTypeAsCFString(thisParam.type)
    if (String(theSQLType).indexOf("CF_SQL") != 0 )
    {
      typeMessage = true
    }

    thisRow[0] = thisParam.name
    thisRow[1] = theSQLType
    thisRow[2] = theDir
    thisRow[3] = ""
    if (theDir == "in" || theDir == "in/out")
    {
      thisRow[4] = "#" + StripChars("@!-_ .,:=", thisParam.name) + "#"
    }
    else
    {
      thisRow[4] = ""
    }

    if (thisRow[2] != "RETURN_VALUE")
    {
      // In CF, there is always a return value.  We won't 
      // show it in the param grid.

      gridArray.push(thisRow)
    }
  }

  PARAM_LIST.setContents(gridArray)
  CFSTOREDPROC_TEXT.value = treeData.procedure

  if (typeMessage)
  {
    alert(MM.MSG_SQLDataTypeUnknown);
  }
}




function LaunchConnectionManager()
{
  var oldList = String(CONN_LIST.valueList).split(",")
  MMDB.showConnectionMgrDialog()
  PopulateConnectionList()
  var newConnectionIndex = getNewConnection(oldList, CONN_LIST.valueList)
  if (newConnectionIndex != -1)
  {
    CONN_LIST.setIndex(newConnectionIndex)
    ConnectionChanged()
  }
}


function getNewConnection(oldList, newList)
{
  var numUnmatched = 0
  var unMatchedIndex= -1
  for (var newCount = 0; newCount < newList.length; newCount++)
  {
    var foundThisOne = false
    for (oldCount = 0; oldCount < oldList.length; oldCount++)
    {
      if (oldList[oldCount] == newList[newCount])
      {
        foundThisOne = true
        break
      }
    }
    if (!foundThisOne)
    {
      numUnmatched++
      if (numUnmatched > 1)
      {
        break
      }
      unMatchedIndex = newCount
    }
  }

  return unMatchedIndex
}


function PlusMouseDown()
{
  PlusButtonMouseDown(PLUS_BUTTON);
}

function PlusMouseUp()
{
  PlusButtonMouseUp(PLUS_BUTTON);
  AddParam();
}

function MinusMouseDown()
{
  if(PARAM_LIST.getIndex() >= 0) {
  MinusButtonMouseDown(MINUS_BUTTON)
  }
}

function MinusMouseUp()
{
  if(PARAM_LIST.getIndex() >= 0) {
  MinusButtonMouseUp(MINUS_BUTTON)
    DeleteParam();
  }
}