/*
CFStoredProcShared.js
---------------------------------------------------
Copyright 2001 Macromedia, Inc. All rights reserved.

This file is shared by the PI and the Init Dialogs
of the CFStoredProc object

*/


/******* GLOBAL VARIABLES BEGIN ******************/

var CONST_TYPE = "cfstoredproc"

var WGHT_CFStoredProcSet = 40
var WGHT_CFStoredProcDefault = 45
var WGHT_CFStoredProc = 50
var WGHT_CFStoredProcRetVal = 54
var WGHT_CFStats = 55

var DEBUG = false

var CFStoredProcMask = "\n<cfstoredproc procedure=\"#procedure#\" datasource=##datasource## #usrpwd# returncode=\"Yes\">"

//Masks for the param tags inside the proc tag

var CFInParamMask = "\n    <cfprocparam type=\"IN\" dbvarname=\"#dbvarname#\" value=\"##value##\" cfsqltype=\"#cfsqltype#\">"
var CFOutParamMask = "\n    <cfprocparam type=\"OUT\" dbvarname=\"#dbvarname#\" cfvarname=\"#cfvarname#\" cfsqltype=\"#cfsqltype#\">"
var CFInOutParamMask = "\n    <cfprocparam type=\"INOUT\" dbvarname=\"#dbvarname#\" value=\"##value##\" cfvarname=\"#cfvarname#\" cfsqltype=\"#cfsqltype#\">"
var CFNameMask = "\n    <!--- mm_procname=\"#procname#\" --->"
var CFProcMask = "\n    <cfprocresult name=\"#name#\">"

var CFEndSPMask = "\n</cfstoredproc>"
var CFRetValMask = "\n<cfset #name#__RETURN_VALUE=CFSTOREDPROC.STATUSCODE>"

//Init block masks

//the following node is referred to as the "set node"
var CFSetMask = "<cfparam name=\"#runtimeVal#\" default=\"#defaultVal#\">"
//the following node is referred to as the "param node"
var CFParamMask = "<cfparam name=\"#varname#\" default=\"##runtimeVal##\">"




var strCFSQLTypeList =  "\nCF_SQL_BIT \nCF_SQL_BIGINT \nCF_SQL_CHAR \nCF_SQL_DATE \nCF_SQL_DECIMAL \n" +
            "CF_SQL_DOUBLE \nCF_SQL_FLOAT \nCF_SQL_IDSTAMP \nCF_SQL_INTEGER \nCF_SQL_LONGVARCHAR \n" +
            "CF_SQL_MONEY \nCF_SQL_MONEY4 \nCF_SQL_NUMERIC \nCF_SQL_REAL \nCF_SQL_SMALLINT \n" +
            "CF_SQL_TIME \nCF_SQL_TIMESTAMP \nCF_SQL_TINYINT \nCF_SQL_VARCHAR "


/******* GLOBAL VARIABLES END ********************/


/******* CUSTOM OBJECT DEFINITIONS BEGIN ********************/

/*
spRec is a superset of ssRecord.  It is the main data structure that holds
information about the stored proc.  This data structure can be filled out in
its entirety by findServerBehaviors() (which gets all the info from the DOM of
the current page) and it can be filled out partially by GetDataFromUI() (which,
obviously, gets the data from the UI.  Of course the node ptrs will still be
null.)

This data structure acts as the "middle man" for most of the functionality
encapsulated in this file.  This way, knowledge of the "UI to DOM" structure does
not have to be "known" by multiple routines. 
*/

function spRec()  // a superset of ssRec
{
  var theRec = new SSRecord()
  theRec.name = ""
  theRec.connectionName = ""
  theRec.procedure = ""
  theRec.username = ""
  theRec.password = ""
  theRec.paramArray = new Array() // array of paramObj's
  theRec.resultNode = null      // the child node of the sp that is the resultset
  theRec.resultsetName = ""
  theRec.numRowsNode = null
  theRec.indexNode = null
  theRec.returnValueNode = null   // the CFSET node that captures the ret val of the sp
  theRec.message = ""       // if incomplete flag set, this would have a message to display
  theRec.severity = ""        // indicates whether or not the incomplete, or erred, object can be
                  // remedied automatically. "ok" means yes, "abort" means no
  theRec.errorMsg = "";
  
  return theRec
}


/*
paramObj's are used to keep info about each parameter of a stored
proc.  An array of paramObj's can be found at spRec.paramArray.
*/

function paramObj()
{
  this.name = ""      // The name of the parameter as it comes from the DB
  this.dbName = ""    // The name of the parameter with @'s stripped 
  this.defaultVal = ""  // The value entered by the user in the "Default Value" column of the param grid
  this.runtimeVal = ""  // The value entered by the user in the "Runtime Value" column of the param grid
              // Currently the user is forced to put #'s around this val, but the #'s are stripped
              // before being saved in this property.             
  this.type = ""      // The "direction" of the parameter: "in", "out", "inout", "return"
  this.cfSQLType = ""   // The Cold Fusion SQL type, such as CF_SQL_INTEGER 
  this.cfNode = null    // The child node of the sp that is this param <cfprocparam ...>
  this.setNode = null   // The node that sets the cfvar to the literal defalut val <cfparam x="100">
  this.paramNode = null // The node that sets the sp param var to the cfvar <cfparam sp1__myParam="#x#">
}


/*******  CUSTOM OBJECT DEFINITIONS END ********************/


function UpdateCFStoredProcInDOM(uiData, priorRec)
{
  var editList = buildSSEdits(uiData, priorRec)

  // We want to replace all the existing chunks with nothing

  for (var i = 0; i < priorRec.participants.length; i++)
  {
    if (priorRec.participants[i] != priorRec.selectedNode && 
        priorRec.types[i] != "connectionref_statement")
    {
      editList.add("", priorRec.participants[i], "replaceNode")
    }
  }

  editList.insert(true);

}


function InsertMe(uiData)
{
  var editList = buildSSEdits(uiData)
  editList.insert();
}



function buildSSEdits(valueNode, priorRec)
{
  var editList = new SSEdits()

  //insert the connection include if necessary
  var connectionRef = new Participant("connectionref_statement");
  var paramObj = new Object();
  paramObj.cname = valueNode.connectionName;    
  paramObj.relpath = getConnectionsPath(paramObj.cname);
  paramObj.ext = getServerExtension();
    
    
  //special case the update of connection_ref, to prevent multiple
  // connection statements from being created
  if (priorRec && 
      (priorRec.parameters.relpath != paramObj.relpath ||
       priorRec.parameters.ext != paramObj.ext) &&
      priorRec.parameters.cname == paramObj.cname) {
    priorRec.MM_forcePriorUpdate = "connectionref_statement";
  }
  
  connectionRef.apply(editList,paramObj, priorRec);
  
  
  // create the init block stuff
  for (var i = 0; i < valueNode.paramArray.length; i++)
  {
    var thisParam = valueNode.paramArray[i]
    if (thisParam.type == "in" || thisParam.type == "inout")
    {
      CreateParamChunk(valueNode.name, thisParam, editList)
    }
  }

  // now create the main node

  var chunk = CFStoredProcMask  
  chunk = chunk.replace(/#name#/g,valueNode.name)

/*
  var connString = MMDB.getDeployConnectionString(valueNode.connectionName);
  if (connString.search(/dsn=(\w+)/gi) != -1)
  {
    //In some case we need to account for local CF we use ADO hence
    //we may land up with something begin with dsn=sample;uid=qa;pwd=qa;
    connString = RegExp.$1;
  }
*/

  var connString = "MM_" + valueNode.connectionName + "_DSN";

  chunk = chunk.replace(/#datasource#/g,connString)
  chunk = chunk.replace(/#procedure#/g,valueNode.procedure)

  //var userName = MMDB.getUserName(valueNode.connectionName)
  //var password = MMDB.getPassword(valueNode.connectionName)
  var userName = "MM_" + valueNode.connectionName + "_USERNAME";
  var password = "MM_" + valueNode.connectionName + "_PASSWORD";
  if (userName || password)
  {
    chunk = chunk.replace(/#usrpwd#/g,"username=#" + userName + "# password=#" + password + "#")
  }
  else
  {
    chunk = chunk.replace(/#usrpwd#/g,"")
  }

  // put the id tag
  chunk += CFNameMask.replace(/#procname#/, valueNode.name)

  // put the resultset tag if the user indicated there is a resultset returned
  if (valueNode.resultsetName != "")
  {
    chunk += CFProcMask.replace(/#name#/, valueNode.resultsetName)
  }

  // each param is a child node of the main node
  chunk += AddParamsToChunk(valueNode)

  chunk += CFEndSPMask 

  gMainNodeSource = chunk

  editList.add(chunk,priorRec?priorRec.selectedNode:null,WGHT_CFStoredProc)

  chunk = CFRetValMask.replace(/#name#/, valueNode.name)

  editList.add(chunk,null,WGHT_CFStoredProcRetVal)

  return editList
}

function CreateParamChunk(rsName, thisParam, editList)
{
  var chunk = CFSetMask
  chunk = chunk.replace("#defaultVal#", thisParam.defaultVal)
  chunk = chunk.replace("#runtimeVal#", thisParam.runtimeVal)
  editList.add(chunk,null,WGHT_CFStoredProcSet)
  
  chunk = CFParamMask
  chunk = chunk.replace("#varname#", rsName + "__" + thisParam.name)
  chunk = chunk.replace("#runtimeVal#", thisParam.runtimeVal)
  editList.add(chunk,null,WGHT_CFStoredProcDefault)
}


function AddParamsToChunk(valueNode)
{
  var params = ""
  var thisChunk 

  for (var i = 0; i < valueNode.paramArray.length; i++)
  {
    var thisParam = valueNode.paramArray[i]
    thisChunk = ""

    switch (thisParam.type)
    {
      case "in":
        thisChunk = CFInParamMask
        break
      case "out":
        thisChunk = CFOutParamMask
        break
      case "inout":
        thisChunk = CFInOutParamMask
        break
    }

    thisChunk = thisChunk.replace(/#dbvarname#/g, thisParam.dbName)
    thisChunk = thisChunk.replace(/#value#/g, valueNode.name + "__" + thisParam.name)
    thisChunk = thisChunk.replace(/#cfsqltype#/g, thisParam.cfSQLType)
    thisChunk = thisChunk.replace(/#cfvarname#/g, valueNode.name + "__" + thisParam.name)

    params += thisChunk
  }

  return params
}

function UpdateRetValNode(uiData, priorRec)
{
  if (uiData.name != priorRec.name)
  {
    priorRec.returnValueNode.outerHTML = CFRetValMask.replace(/#name#/, uiData.name)
  }
}

function DeleteAllParamNodes(pa)
{
  //we are dealing with param recs from
  //an ssRec

  for (var i = 0; i < pa.length; i++)
  {
    if (pa[i].type != "out")
    {
      pa[i].setNode.outerHTML = ""
      pa[i].paramNode.outerHTML = ""
    }
  }
}

function UpdateMainNode(uiData, priorRec)
{
  var mainNode = priorRec.selectedNode

  if (uiData.name != priorRec.name)
  {
    mainNode.setAttribute("name", uiData.name)
  }

  if (uiData.connectionName != priorRec.connectionName)
  {
    mainNode.setAttribute("datasource", uiData.connectionName)
  }

  if (uiData.procedure != priorRec.procedure)
  {
    mainNode.setAttribute("procedure", uiData.procedure)
  }

/*
  usr/pwd stuff here

  if (uiData.name != priorRec.name)
  {
    mainNode.setAttribute("name", uiData.name)
  }
*/
  // Update the CFPROCPARAM, CFPROCRESULT, and MMPROCNAME tags
  UpdateChildNodes(uiData, priorRec)
}

function UpdateChildNodes(uiData, priorRec)
{
  // For now, we just fry everything
  // and rebuild it.

  var mainNode = priorRec.selectedNode

  var strOut = ""
  
  strOut += CFNameMask.replace(/#procname#/, uiData.name)

  if (uiData.resultsetName != "")
  {
    strOut += CFProcMask.replace(/#name#/, uiData.resultsetName)
  }

  strOut += AddParamsToChunk(uiData)

  mainNode.innerHTML = strOut
}


function UpdateParamNodes(uiData, priorRec)
{
  var uiParams = uiData.paramArray
  var domParams = priorRec.paramArray

  // match up the existing params with the new UI params

  var uiMatched = new Array()
  var domMatched = new Array()

  //initialize all the uiParams to be unmatched
  for (var i = 0; i < uiParams.length; i++)
  {
    uiMatched[i] = false
  }

  for (var i = 0; i < domParams.length; i++)
  {
    var thisDomParam = domParams[i]
    domMatched[i] = null

    //can we find a match in the UI params?
    for (var j = 0; j < uiParams.length; j++)
    {
      var thisUIParam = uiParams[j]
      if (thisUIParam.name == thisDomParam.name)
      {
        uiMatched[j] = true
        domMatched[i] = thisUIParam
        break
      }
    }
  }

  // When we get here, we will have filled in the two
  // arrays.  
  // 1) uiMatched[i]....true for each UIParam that has a matching domParam
  // 2) domMatched[i]...a ptr to the matching UI Param or null


  // Update the matched dom params that need it.
  for (var i = 0; i < domParams.length; i ++)
  {
    if (domMatched[i] != null)
    {
      var thisDomParam = domParams[i]
      var thisUIParam = domMatched[i]

      if (thisDomParam.defaultVal != thisUIParam.defaultVal)
      {
        thisDomParam.setNode.setAttribute("default", thisUIParam.defaultVal)
      }

      if (thisDomParam.runtimeVal != thisUIParam.runtimeVal)
      {
        thisDomParam.paramNode.setAttribute("default", "#" + thisUIParam.runtimeVal + "#")
        thisDomParam.setNode.setAttribute("name", thisUIParam.runtimeVal)
      }
    }
  }

  // Delete the unmatched DOM Params
  for (var i = 0; i < domParams.length; i ++)
  {
    if (domMatched[i] == null)
    {
      domParams[i].setNode.outerHTML = ""
      domParams[i].paramNode.outerHTML = ""
    }
  }

  // Create new params for unmatched UI Params
  var editList = new SSEdits()

  for (var i = 0; i < uiParams.length; i++)
  {
    if (uiMatched[i] == false && uiParams[i].type != "out")
    {
      CreateParamChunk(uiData.name, uiParams[i], editList)
    }
  } 

  editList.insert();
}

