// Copyright 2001 Macromedia, Inc. All rights reserved.
/* loc_strings.js
*
* strings.js and loc_strings.js contain arrays for populating select lists 
* in tag dialogs. Both files use the naming convention arrayNameCap for the
* option labels (i.e., text that will be shown to the user) and arrayNameVal
* for the option values(i.e., the code that will be inserted into the document).
* 
* for obvious reasons, loc_strings.js mainly contains the Cap arrays, and
* strings.js mainly contains the Val arrays. only loc_strings.js should be
* localized.  
*
* note: where the labels should not be localized, select lists are intialized
* using the Val array for both the labels and the values.
* 
*/

//--------------- LOCALIZEABLE GLOBALS---------------

var theLookAndFeelCap = new Array("motif","windows","metal");
var theExitMethodsCap = new Array("exittag", "exittemplate", "loop"); 
var theSubmissionMethodsCap = new Array("POST", "GET"); 
var theVericalAlignmentsCap = new Array("ABSBOTTOM", "ABSMIDDLE", "BASELINE","BOTTOM", "LEFT","MIDDLE", "RIGHT","TEXTTOP","TOP"); 
var theAlignmentsCatchCap = new Array("Application", "Database", "Template","Object", "Synchronization","MissingInclude", "Expression","Lock","Any");
var theAlignmentsColCap = new Array("left", "right", "center"); 
var theTypesContentCap = new Array("text/html", "text/plain", "application/msword", "application/msexcel", 
               "application/poscript", "application/x-zip-compressed", "application/pdf", 
               "application/rtf", "video/x-msvideo", "video/quicktime", "video/x-mpeg2", "audio/x-pn/realaudio", 
               "audio/x-mpeg", "audio/x-waw", "audio/x-aiff", "audio/x-aiff", "audio/basic", "image/tiff", 
               "image/jpeg", "image/gif", "image/x-png", "image/x-photo-cd", "image/x-MS-bmp", 
               "mage/x-rgb", "image/x-portable-pixmap", "image/x-portable-greymap", "image/x-portablebitmap"); 
               
var theExpiresCap = new Array("NOW", "NEVER");        
var theLanCollectionCap = new Array("English", "German", "Finnish", "French", "Danish", "Dutch", "Italian", "Norwegian", "Portuguese", "Spanish", "Swedish"); 
var theSelCollectionCap = new Array("Create", "Delete", "Map", "Optimize", "Repair"); 
var theSelPopCap = new Array("getall", "getheaderonly", "delete"); 
var theSelDirectoryCap = new Array("List","Create","Delete","Rename"); 
var theSelFileCap = new Array("Upload", "Copy", "Move", "Rename", "Delete", "Append", "Write", "Read", "ReadBinary"); 
var theFileNameConflictCap = new Array("Error", "Skip", "Overwrite", "Makeunique"); 
var theSelectModeCap = new Array("BROWSE","COLUMN","EDIT","ROW","SINGLE"); 
var theGridDataAlignCap = new Array("LEFT","CENTER","RIGHT"); 
var theGridColTypeCap = new Array("IMAGE", "NUMERIC", "STRING_NOCASE","BOOLEAN"); 
var theSelHeaderCap = new Array("Header", "Status"); 
var theSelInvokeCap = new Array("Component","Web Service"); 
var theHTTPMethodCap = new Array("GET","POST"); 
var theHTTPPARAMTypeCap = new Array("FORMFIELD", "URL", "COOKIE", "FILE", "CGI"); 
var theTransactionActionCap = new Array("BEGIN", "COMMIT", "ROLLBACK"); 
var theTransactionIsolationCap = new Array("READ_UNCOMMITTED", "READ_COMMITTED", "REPEATABLE_READ", "SERIALIZABLE"); 
var theObjectActionCap = new Array("Create","Connect"); 
var theObjectCOMContextCap = new Array("Inproc","Local","Remote"); 
var theObjectCORBAContextCap = new Array("IOR","NameService"); 
var theSelObjectCap = new Array("Component","ComDCom", "Corba", "Java"); 
var theSearchTypeCap = new Array("Simple", "Explicit"); 
var theServletparamTypeCap = new Array("Bool", "Date", "Double", "Int", "String"); 

var theSelLoopCap = new Array("Index Loop", "Conditional Loop", "Query Loop", "List Loop", "Collection Loop"); 
var theQueryParamTypeCap = new Array("CF_SQL_BIGINT","CF_SQL_BIT","CF_SQL_CHAR","CF_SQL_DATE","CF_SQL_DECIMAL",
                    "CF_SQL_DOUBLE","CF_SQL_FLOAT","CF_SQL_IDSTAMP","CF_SQL_INTEGER","CF_SQL_LONGVARCHAR",
                    "CF_SQL_MONEY","CF_SQL_MONEY4","CF_SQL_NUMERIC","CF_SQL_REAL","CF_SQL_REFCURSOR","CF_SQL_SMALLINT",
                    "CF_SQL_TIME", "CF_SQL_TIMESTAMP", "CF_SQL_TINYINT","CF_SQL_VARCHAR"); 
var theSelRegistryCap = new Array("GetAll", "Get", "Set", "Delete"); 
var theRegistryTypeCap = new Array("String","DWORD","Key","Any");
var theParamTypeCap = new Array("any","array","boolean","binary","date","numeric","query","string","struct","UUID","variableName"); 
var theLockTypeCap = new Array("EXCLUSIVE","READONLY"); 
var theLockScopeCap = new Array("SESSION","APPLICATION","SERVER"); 
var theImpersonateTypeCap = new Array("CF","OS"); 
var theProcparamTypeCap = new Array("In", "Out", "InOut"); 
var theProcparamCFSQLTypeCap = new Array("CF_SQL_BIGINT","CF_SQL_BIT","CF_SQL_CHAR","CF_SQL_DATE","CF_SQL_DECIMAL",
                                         "CF_SQL_DOUBLE","CF_SQL_FLOAT","CF_SQL_IDSTAMP","CF_SQL_INTEGER","CF_SQL_LONGVARCHAR",
                                         "CF_SQL_MONEY","CF_SQL_MONEY4","CF_SQL_NUMERIC","CF_SQL_REAL","CF_SQL_SMALLINT","CF_SQL_TIME",
                                         "CF_SQL_TIMESTAMP","CF_SQL_TINYINT","CF_SQL_VARCHAR"); 
var theSelMailparamCap = new Array("Header","File");                                          
var theSelCFFTPCap = new Array ("listdir", "getfile", "putfile", "open", "close", "changedir", "createdir", "rename", "remove", "getcurrentdir", "getcurrenturl", "exists", "existsdir", "existsfile","removedir"); 
var theCFFTPTransferModeCap = new Array("AUTO","ASCII", "BINARY"); 
var theSelCFLDAPCap = new Array("query", "add", "modify", "modifydn", "delete"); 
var theIndexTypeCap = new Array("File", "Refresh", "Path", "Custom"); 
var theSelIndexCap = new Array("Update", "Refresh", "Delete", "Purge"); 
var theSelInputCap = new Array("Text", "Radio", "Checkbox", "Password"); 
var theInputValidateCap = new Array("date","eurodate","time","float","integer","telephone","zipcode","creditcard","social_security_number","regular_expression (CF5.0 required)"); 
var theInsertDBTypeCap = new Array("ODBC","OLEDB","Oracle73","Oracle80","Sybase11","DB2","Informix73"); 
var theMailTypeCap = new Array("Plain Text","HTML"); 
var theSelCfwddxCap = new Array("cfml2wddx", "wddx2cfml", "cfml2js", "wddx2js"); 
var theQueryDBTypeCap = new Array("Dynamic","Query","ODBC","OLEDB","Oracle73","Oracle80","Sybase11","DB2","Informix73"); 
var theSelCacheCap = new Array("Cache", "Flush", "Clientcache", "Optimal"); 
var theErrorTypesCap = new Array("exception", "monitor", "request", "validation");
var theScopeCfldapCap = new Array("ONELEVEL","BASE","SUBTREE"); 
var theModifyTypeCfldapCap = new Array("ADD","DELETE","REPLACE"); 
var theOperationCfscheduleCap = new Array("HTTPRequest"); 
var theSelCfscheduleCap = new Array("Update","Delete","Run"); 
var theLogLogCap = new Array("Application","Scheduler"); 
var theTypeLogCap = new Array("Information", "Warning", "Error", "Fatal Information"); 
var theSelGraphCap = new Array("bar","line","pie");
var theFileFormatGraphCap = new Array("Flash","jpg","png"); 
var theShowValueLabelGraphCap = new Array("Yes","No","Rollover"); 
var theValueLabelFontGraphCap = new Array("Arial","Courier","Times"); 
var theItemLabelFontGraphCap = new Array("Arial","Courier","Times"); 
var theTitleFontGraphCap = new Array("Arial","Courier","Times"); 
var theShowLegendGraphCap = new Array("above","below","left","right","none"); 
var theValueLocationGraphCap = new Array("onBar","overBar"); 
var theValueLocationPieCap = new Array("inside","outside");
var theItemLabelOrientationGraphCap = new Array("horizontal","vertical"); 
var theShowLegendGraphCap = new Array("above", "below", "left", "right", "none"); 
var theLegendFontGraphCap = new Array("Arial","Courier","Times"); 

// CFC strings to localize 
var theTypesCap  = new Array("any","array","binary","boolean","date","numeric","query","string","struct","UUID","variableName");
var theAccessCap = new Array("private","package","public","remote"); 
var theTraceTypeCap = new Array("information","warning","error","fatal information"); 
var theObjectcacheActionCap = new Array("clear"); 
var theChartSeriesTypeCap = new Array("area","bar","cone","curve","cylinder","line","pie","pyramid","scatter","step","sphere"); 
var theChartSeriesPaintStyleCap = new Array("plain","raise","shade","light"); 
var theChartSeriesMarkerStyleCap = new Array("rectange","triangle","diamond","circle","letterx","mcross","snow","rcross");

var theChartFormatCap = new Array("flash","jpg","png"); 
var theChartSeriesplacementCap = new Array("default","cluster","stacked","percent"); 
var theChartLabelformatCap = new Array("number","currency","percent","date"); 
var theChartTipstyleCap = new Array("MouseDown","MouseOver","Off"); 
var theChartPieSliceStyleCap = new Array("solid","sliced"); 

//--------------- END LOCALIZEABLE   ---------------
