// Copyright 2001 Macromedia, Inc. All rights reserved.
/* loc_strings.js
*
* strings.js and loc_strings.js contain arrays for populating select lists 
* in tag dialogs. Both files use the naming convention arrayNameCap for the
* option labels (i.e., text that will be shown to the user) and arrayNameVal
* for the option values(i.e., the code that will be inserted into the document).
* 
* for obvious reasons, loc_strings.js mainly contains the Cap arrays, and
* strings.js mainly contains the Val arrays. only loc_strings.js should be
* localized.  
*
* note: where the labels should not be localized, select lists are intialized
* using the Val array for both the labels and the values.
* 
*/

//--------------- LOCALIZEABLE GLOBALS---------------

var theAlignCaptionCap = new Array("top", "bottom", "left", "right");
var theAlignImgCap = new Array("Baseline", "Top", "Middle", "Bottom","Textop","Absolute Middle","Absolute Bottom","Left","Right");
var theAlignLegendCap = new Array("left", "right", "center - MSIE 4+ only"); 
var theAlignObjectCap = new Array("top","bottom","middle","left","right");
var theAlignsHRCap = new Array("left","center (default)","right"); 
var theAlignStandardFourCap = new Array("left", "center", "right","justify - version 4 browsers only"); 
var theAlignTableCap = new Array("Default", "left", "right", "center"); 
var theAreaShapesCap = new Array("default","rect","circle","poly");

var theCellScopesCap = new Array("col","colgroup","row","rowgroup");
var theCharsetsCap = new Array("Latin 1 - Western European (ISO-8859-1)","Latin 2 - Central European (ISO-8859-2)","Latin 3 - South European (ISO-8859-3)","Latin 4 - North European (ISO-8859-4)","Latin 5 - Turkish (ISO-8859-9)???","Latin 6 - Nordic (ISO-8859-10)","Latin 9/Latin 0 (ISO-8859-15)","Cyrillic (ISO-8859-5)","Arabic (ISO-8859-6)","Greek (ISO-8859-7)","Hebrew (ISO-8859-8)","ISO-10646 (Latin-1 subset of Unicode)","ISO-10646-UCS-2 (2-octet Basic Multilingual Plane)","ISO-10646-UCS-4 (full code space)","Unicode (UTF-7)","Unicode (UTF-8)","US-ASCII","KOI8-R (INIS-Cyrillic)","Japanese (JIS)","Japanese (EUC-JP - Extended UNIX Code Packed Format)","Japanese (Shift_JIS - MS_Kanji)","Chinese Simplified (EUC-CN)","Chinese (GB2312 8-bit )","Chinese (GBK - simplified zh_CN Mainland Chinese)","Taiwanese (Big5 - traditional zh_TW Chinese hanzi)","Korean (UHC - UnifiedHangul)","Vietnamese (VISCII 8-bit)","windows-1250 - CP1250 (WinLatin2)","windows-1251 - CP1251 (WinCyrillic)","windows-1252 - CP1252 (WinLatin1)","windows-1253 - CP1253 (WinGreek)","windows-1254 - CP1254 (WinTurkish)","windows-1255 - CP1255 (WinHebrew)","windows-1256 - CP1256 (WinArabic)","windows-1257 - CP1257 (WinBaltic)","windows-1258 - CP1258 (WinVietnamese)");
var theClearBRCap = new Array("none (default)", "left", "right", "all"); 

var theDirectionCap = new Array("left-to-right","right-to-left"); 

var theFontSizesFontCap = new Array("None","1","2","3","4","5","6","+1","+2","+3","+4","+5","+6","-1","-2","-3","-4","-5","-6");
var theFrameScrollingCap = new Array("auto (default)","yes","no");


var theHAlignCap = new Array("left", "center", "right", "justify - version 4 browsers only"); 
var theHTTPMetaCap = new Array("None", "Content-Type", "Refresh", "Expires", "Description", "Keywords", "Reply-to", "PICS-Label"); 

var theImgAltCap = new Array("[empty string]");
var theImgStartCap = new Array("fileopen (default)","mouseover");
var theInputTypesCap = new Array("text","password","radio","checkbox","image","file","hidden","button","submit","reset");

var theLanguagesCap = new Array("af Afrikaans", "sq Albanian", "ar Arabic (needs subtype)", 
                                 "eu Basque", "br Breton", "bg Bulgarian","be Belarusian",
                                  "ca Catalan","zh Chinese (needs subtype)","hr Croatian",
                                  "cs Czech", "da Danish","nl Dutch (Standard)","en English",
                                  "et Estonian","fo Faeroese","fa Farsi","fi Finnish","fr French (Standard)",
                                  "gd Gaelic (Scotland)","de German (Standard)","el Greek",
                                  "he Hebrew","hi Hindi","hu Hungarian","is Icelandic","id Indonesian",
                                  "it Italian (Standard)","ja Japanese","ko Korean","lv Latvian",
                                  "lt Lithuanian","mk Macedonian","ms Malaysian","mt Maltese",
                                  "no Norwegian (Bokmal/Nynorsk)","pl Polish","pt Portuguese (Standard)",
                                  "rm Rhaeto-Romanic","ro Romanian","ru Russian","sz Sami (Lappish)",
                                  "sr Serbian (Cyrillic/Latin)","tn Setswana","sk Slovak",
                                  "sl Slovenian","es Spanish (Spain)","sx Sutu","sv Swedish",
                                  "th Thai","ts Tsonga","tr Turkish","uk Ukrainian","ur Urdu",
                                  "vi Vietnamese","xh Xhosa","yi Yiddish","zu Zulu"); 
var theLinkTypesCap = new Array("alternate","stylesheet","start","next","prev","contents","index","glossary","copyright","chapter","section","subsection","appendix","help","bookmark");
var theListTypesCap = new Array("Ordered List","Unordered List");
var theLoopsBGSoundCap = new Array("infinite (-1)"); 

var theMIMETypesCap =  new Array("text/html", "text/plain", "application/msword", "application/msexcel", "application/postscript", "application/x-zip-compressed", "application/pdf", "application/rtf", "video/x-msvideo", "video/quicktime", "video/x-mpeg2", "audio/x-pn/realaudio", "audio/x-mpeg", "audio/x-waw", "audio/x-aiff", "audio/basic", "image/tiff", "image/jpeg", "image/gif", "image/x-png", "image/x-photo-cd", "image/x-MS-bmp", "image/x-rgb", "image/x-portable-pixmap", "image/x-portable-greymap", "image/x-portable-greymap", "image/x-portablebitmap"); 


var theNameMetaCap = new Array("None", "Description", "Keywords", "Expires","Reply-to","PICS-Label"); 

var theOLTypesCap = new Array("1. arabic (default)","a. lower alpha","A. upper alpha","i. lower roman","I. upper roman");

var theTypeButtonCap = new Array("submit (default in HTML 4.0)", "reset", "button (default in IE)"); 

var theULTypesCap = new Array("(default)","disc","circle","square");
var theVAlignStandardFourCap = new Array("top", "middle", "bottom","baseline"); 

var theValueTypesParamCap = new Array("data - default", "ref", "object"); 

var theWrapTACap = new Array("Default", "off","virtual","physical"); 

//--------------- END LOCALIZEABLE   ---------------
